//
//  MyDocument.m
//  EasyMD5
//
//  Created by Peter Hosey on 2007-03-29.
//  Copyright Peter Hosey 2007 . All rights reserved.
//

#import "MyDocument.h"

@implementation MyDocument

- (NSString *)windowNibName {
	return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
}

- (NSString *) MD5Sum {
	return MD5Sum;
}
- (void) setMD5Sum:(NSString *)newMD5Sum {
	if(MD5Sum != newMD5Sum) {
		[MD5Sum release];
		MD5Sum = [newMD5Sum copy];
	}
}

- (BOOL)readFromURL:(NSURL *)absoluteURL ofType:(NSString *)typeName error:(NSError **)outError {
	NSTask *task = [[NSTask alloc] init];

	NSFileHandle *stdinFH = [NSFileHandle fileHandleForReadingAtPath:[absoluteURL path]];
	[task setStandardInput:stdinFH];

	NSPipe *stdoutPipe = [NSPipe pipe];
	[task setStandardOutput:stdoutPipe];

	[task setLaunchPath:@"/usr/bin/openssl"];
	[task setArguments:[NSArray arrayWithObject:@"md5"]];

	[task launch];

	NSData *MD5Data = [[stdoutPipe fileHandleForReading] readDataToEndOfFile];
	[self setMD5Sum:[[[[NSString alloc] initWithData:MD5Data encoding:NSASCIIStringEncoding] autorelease] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]]];

	return (MD5Sum != nil);
}
- (BOOL)writeToURL:(NSURL *)absoluteURL ofType:(NSString *)typeName error:(NSError **)outError {
	return NO;
}

@end
